Генерирование исключений вручную
Оценка 4.8

Генерирование исключений вручную

Оценка 4.8
docx
18.11.2021
Генерирование исключений вручную
Л2-002136.docx

Генерирование исключений вручную

Если пользователь обнаружил в своем методе ошибку, то он может сгенерировать исключение вручную, используя инструкцию throw.

Вызывающая метод программа должна быть готова обработать это исключение.

 

Формат ее записи таков:

 

throw exceptOb;

 

Элемент exceptOb это объект класса исключений, производного от класса Exception.

 

throw передает управления в CLR.


Пример 1. Генерирование стандартного исключения.

using System; class Class1

{

public static int Divide (int a, int b)

{

if (b == 0)

throw new DivideByZeroException(); else

return a / b;

}

}

 

class Demo

{

public static void Main()

{

 

try

{

Console.WriteLine("a/b=" + Class1.Divide(4, 0));

}

catch (DivideByZeroException)

{

Console.WriteLine("На ноль делить нельзя!");

}

}

}

 

Пример 2. Генерирование пользовательского исключения.

 

// Деление пополам числа, которое должно быть четным. using System;

 

class Class1

{

public static int Divide2(int a)

{

if ( (float)(a / 2) > 0 )

throw new Exception ("Число должно быть четным."); else

return a / 2;

}

}

 

class Demo

{

public static void Main()

{


try

{

Class1.Divide2 (3);

}

catch (Exception e)

{

Console.WriteLine("ERROR: " + e.Message);

}

}

}

 


 

Генерирование исключений вручную

Генерирование исключений вручную

Пример 1. Генерирование стандартного исключения

Пример 1. Генерирование стандартного исключения

Class1.Divide2 (3); } catch (Exception e) {

Class1.Divide2 (3); } catch (Exception e) {
Материалы на данной страницы взяты из открытых истончиков либо размещены пользователем в соответствии с договором-офертой сайта. Вы можете сообщить о нарушении.